package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.ContainerData;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.MatterRegistry;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterDecomposer;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatteryPoweredMachine;
import ru.dbotthepony.mc.otm.menu.data.BigDecimalDataContainer;
import ru.dbotthepony.mc.otm.menu.slot.MachineInputSlot;
import ru.dbotthepony.mc.otm.menu.slot.MachineOutputSlot;

import javax.annotation.Nullable;

public class MatterDecomposerMenu extends PoweredMatteryMenu {
	public MatterDecomposerMenu(int containerID, Inventory inventory) {
		this(containerID, inventory, null);
	}

	public BigDecimalDataContainer matter;
	public BigDecimalDataContainer max_matter;

	public ContainerData progress;

	public MatterDecomposerMenu(int containerID, Inventory inventory, @Nullable BlockEntityMatterDecomposer tile) {
		super(Registry.Menus.MATTER_DECOMPOSER, containerID, inventory, tile);
		Container container = tile != null ? tile.item_container : new SimpleContainer(2);

		progress = new ContainerData() {
			int get_value;

			@Override
			public int get(int i) {
				if (tile != null)
					return (int) (tile.getWorkProgress() * 100);

				return get_value;
			}

			@Override
			public void set(int i, int i1) {
				get_value = i1;
			}

			@Override
			public int getCount() {
				return 1;
			}
		};

		// Вход
		addSlot(new MachineInputSlot(container, 0, 61, 36) {
			@Override
			public boolean mayPlace(ItemStack p_40231_) {
				return MatterRegistry.hasMatterValue(p_40231_);
			}
		});

		// Выход
		addSlot(new MachineOutputSlot(container, 1, 61 + 18 + 10 + 3 + 22, 36, true, true));

		if (tile == null) {
			matter = new BigDecimalDataContainer();
			max_matter = new BigDecimalDataContainer();
		} else {
			matter = new BigDecimalDataContainer() {
				@Override
				protected void updateValue() {
					setDecimal(tile.matter.getStoredMatter());
				}
			};

			max_matter = new BigDecimalDataContainer() {
				@Override
				protected void updateValue() {
					setDecimal(tile.matter.getMaxStoredMatter());
				}
			};
		}

		addBatterySlot(14);

		addInventorySlots();

		this.addDataSlots(matter);
		this.addDataSlots(max_matter);

		this.addDataSlots(progress);
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 1;
	}
}
