package ru.dbotthepony.mc.otm.menu.widget;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.GameRenderer;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;
import ru.dbotthepony.mc.otm.screen.MatteryScreen;

abstract public class VerticalGaugeWidget<T extends MatteryMenu> extends AbstractWidget<T> {
	public VerticalGaugeWidget(T menu, int x, int y) {
		super(menu, x, y);
	}

	abstract float getLevel();

	@Override
	public void renderBackground(MatteryScreen<T> screen, PoseStack pose, int local_x, int local_y, int mouse_x, int mouse_y) {
		RenderSystem.setShader(GameRenderer::getPositionTexShader);
		RenderSystem.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
		RenderSystem.setShaderTexture(0, TEXTURE);

		screen.blit(pose, local_x + x, local_y + y, getImageX(), getImageY(), getImageWidth(), getImageHeight());
		float level = getLevel();

		if (level > 0.01f) {
			int intHeight = (int) Math.floor(level * (float) getImageHeight() + 0.5f);
			screen.blit(pose, local_x + x, local_y + y + getImageHeight() - intHeight, getImageX() + getImageWidth(), getImageY() + getImageHeight() - intHeight, getImageWidth(), intHeight);
		}
	}
}
